#define MyAppName "HiroDelphi"
#define MyAppPublisher "Verity"
#define MyAppExeName "HiroDelphi.exe"

#define SrcApp "K:\Projetos\HIRO\documentacao para homologacao dll Hiro\HiroSDK\Exemplos utilizacao DLL\Delphi\HiroDelphi.exe"
#define v1 
#define v2
#define v3
#define v4
#define FileVerStr ParseVersion(SrcApp, v1, v2, v3, v4)
#define MyAppVersion Str(v1) + '.' + Str(v2) + '.' + Str(v3)

[Setup]
SourceDir=K:\Projetos\HIRO\documentacao para homologacao dll Hiro\HiroSDK\Exemplos utilizacao DLL\Delphi

AppId={{034E73BF-C23F-470C-996A-64BF9EB698D0}
AppName={#MyAppName}
AppVersion={#MyAppVersion}
AppVerName={#MyAppName} {#MyAppVersion}
AppPublisher={#MyAppPublisher}
AppCopyright={#MyAppPublisher}
DefaultDirName={pf}\HiroDelphi
DefaultGroupName=HiroDelphi
AllowNoIcons=yes
;OutputDir=C:\TMP
OutputDir=D:\Tmp
OutputBaseFilename=HiroDelphiSetup_{#MyAppVersion}
Compression=lzma
SolidCompression=yes

[Languages]
Name: "brazilianportuguese"; MessagesFile: "compiler:Languages\BrazilianPortuguese.isl"

[Tasks]
Name: "desktopicon"; Description: "{cm:CreateDesktopIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked
Name: "register"; Description: "Registrar Componentes Hiro DLL"; Flags: unchecked
[Files]
Source: *; DestDir: {app}; Flags: ignoreversion; Excludes: HiroDelphiSetup2.exe; 

[Icons]
Name: "{group}\{#MyAppName}"; Filename: "{app}\{#MyAppExeName}"
Name: "{group}\{cm:UninstallProgram,{#MyAppName}}"; Filename: "{uninstallexe}"
Name: "{commondesktop}\{#MyAppName}"; Filename: "{app}\{#MyAppExeName}"; Tasks: desktopicon

[Run]
Filename: {win}\Microsoft.NET\Framework\v4.0.30319\RegAsm.exe; Parameters: "{app}\Hiro.DLL"; StatusMsg: "Registrando Componentes Hiro DLL"; Tasks: register
Filename: {win}\regtlib.exe; Parameters: "{app}\Hiro.TLB"; StatusMsg: "Registrando Componentes Hiro DLL"; Tasks: register
Filename: "{app}\{#MyAppExeName}"; Description: "{cm:LaunchProgram,{#StringChange(MyAppName, '&', '&&')}}"; Flags: nowait postinstall skipifsilent
