unit Operacoes;

interface

//Adicionar a referncia a Hiro_TLB nos uses.
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Registry, Dialogs, StdCtrls, Hiro_TLB, Vcl.ExtCtrls;

type
  TfrmPrincipal = class(TForm)
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Timer1: TTimer;
    Panel1: TPanel;
    btnGetAbastecimento: TButton;
    btnGetStMedidor: TButton;
    btnGetAbs3: TButton;
    btnLiberaAbs: TButton;
    btnPAFECF: TButton;
    Button6: TButton;
    btnGetHorarioTotais: TButton;
    btnSetHorarioTotais: TButton;
    btnGetCombustivel: TButton;
    btnSetCombustivel: TButton;
    btnGetDestinatarios: TButton;
    Button2: TButton;
    btnGetUserSMTP: TButton;
    btnSetUserSMTP: TButton;
    btnGetConfigSMTP: TButton;
    btnSetConfigSMTP: TButton;
    btnGetConfigLAN: TButton;
    btnSetConfigLAN: TButton;
    btnApagarAbast: TButton;
    btnApagarConfiguracao: TButton;
    btnDeleteCartao3: TButton;
    btnDeleteCartao2: TButton;
    btnDeleteCartao1: TButton;
    btnGetCartao2: TButton;
    btnGetCartao1: TButton;
    btnSetCartao: TButton;
    btnSetLitrosAbast: TButton;
    btnsetValorAbast: TButton;
    btnBloquearBico: TButton;
    btnDesbloquearBico: TButton;
    btnSetPrecoBico: TButton;
    btnGetPrecoBico: TButton;
    Button1: TButton;
    btnGetMemoriaAbast: TButton;
    btnGetAbastSemApagar: TButton;
    btnGetStatusBico: TButton;
    btnGetConfigBico: TButton;
    btnSetBico: TButton;
    btnGetRelogio: TButton;
    btnSetRelogio: TButton;
    btnGetVersao: TButton;
    btnSetID: TButton;
    btnSetNumSerie: TButton;
    btnTestarComunicacao: TButton;
    btnTimerStBico: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    lbDataStatus: TLabel;
    lbResultado: TLabel;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    ComboTCP: TComboBox;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    procedure btnTestarComunicacaoClick(Sender: TObject);
    procedure btnSetNumSerieClick(Sender: TObject);
    procedure btnSetIDClick(Sender: TObject);
    procedure btnGetVersaoClick(Sender: TObject);
    procedure btnSetRelogioClick(Sender: TObject);
    procedure btnGetRelogioClick(Sender: TObject);
    procedure btnSetBicoClick(Sender: TObject);
    procedure btnGetConfigBicoClick(Sender: TObject);
    procedure btnGetStatusBicoClick(Sender: TObject);
    procedure btnGetAbastecimentoClick(Sender: TObject);
    procedure btnGetAbastSemApagarClick(Sender: TObject);
    procedure btnGetMemoriaAbastClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnGetPrecoBicoClick(Sender: TObject);
    procedure btnSetPrecoBicoClick(Sender: TObject);
    procedure btnDesbloquearBicoClick(Sender: TObject);
    procedure btnBloquearBicoClick(Sender: TObject);
    procedure btnsetValorAbastClick(Sender: TObject);
    procedure btnSetLitrosAbastClick(Sender: TObject);
    procedure btnSetCartaoClick(Sender: TObject);
    procedure btnGetCartao1Click(Sender: TObject);
    procedure btnGetCartao2Click(Sender: TObject);
    procedure btnDeleteCartao1Click(Sender: TObject);
    procedure btnDeleteCartao2Click(Sender: TObject);
    procedure btnDeleteCartao3Click(Sender: TObject);
    procedure btnApagarConfiguracaoClick(Sender: TObject);
    procedure btnApagarAbastClick(Sender: TObject);
    procedure btnSetConfigLANClick(Sender: TObject);
    procedure btnGetConfigLANClick(Sender: TObject);
    procedure btnSetConfigSMTPClick(Sender: TObject);
    procedure btnGetConfigSMTPClick(Sender: TObject);
    procedure btnSetUserSMTPClick(Sender: TObject);
    procedure btnGetUserSMTPClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure btnGetDestinatariosClick(Sender: TObject);
    procedure btnSetCombustivelClick(Sender: TObject);
    procedure btnGetCombustivelClick(Sender: TObject);
    procedure btnSetHorarioTotaisClick(Sender: TObject);
    procedure btnGetHorarioTotaisClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure testeCom(tipo: String);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure btnPAFECFClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    function GetAppVersionStr: String;
    procedure btnLiberaAbsClick(Sender: TObject);
    procedure btnGetAbs3Click(Sender: TObject);
    procedure btnGetStMedidorClick(Sender: TObject);
    procedure btnTimerStBicoClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPrincipal: TfrmPrincipal;
  //Declarao das variaveis necessrias para a comunicao.
  comunicacao: TComunicacaoDelphi;
  statusComunicacao: EStatusDaComunicacaoConcentrador;
  statusComando: EStatusComando;

implementation

{$R *.dfm}

//Testa a comunicao com o concentrador.
procedure TfrmPrincipal.btnTestarComunicacaoClick(Sender: TObject);
var
  T1 : Cardinal;
  T2 : Cardinal;
  sT : string;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        case ComboTCP.ItemIndex of
          0: comunicacao.PortaTCPFixa:=2001;
          1: comunicacao.PortaTCPFixa:=3001;
          2: comunicacao.PortaTCPFixa:=1771;
          else comunicacao.PortaTCPFixa:=0;
        end;

        comunicacao.PAF_ECF_COMMtimeout:=true;

        T1 := GetTickCount;
        statusComunicacao := comunicacao.TestarComunicacao();
        T2 := GetTickCount;
        sT := FormatFloat(',0', T2 - T1) + 'ms';
        if statusComunicacao = EStatusDaComunicacaoConcentrador_OK then
                Showmessage('Comunicao efetuada com sucesso. T:' + sT)
        else
                Showmessage('Falha na comunicao. T:' + sT)
end;

procedure TfrmPrincipal.btnTimerStBicoClick(Sender: TObject);
begin
  if btnTimerStBico.Tag = 0 then
  begin
     Panel1.Visible:=False;
     Panel2.Visible:=True;
     Timer1.Enabled:=True;
     btnTimerStBico.Tag:=1;
     btnTimerStBico.Caption:='Parar Timer!';
  end
  else
  begin
     Timer1.Enabled:=False;
     Panel1.Visible:=True;
     Panel2.Visible:=False;
     btnTimerStBico.Caption:='Timer Status Bicos';
     btnTimerStBico.Tag:=0;
  end;
end;

//Seta o nmero de srie do concentrador.
procedure TfrmPrincipal.btnSetNumSerieClick(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.SetNumeroSerieConcentrador('1234');
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Seta o ID do concetrador.
procedure TfrmPrincipal.btnSetIDClick(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.SetIDConcentrador(1);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Busca a verso do hardware do cncentrador.
procedure TfrmPrincipal.btnGetVersaoClick(Sender: TObject);
var
        concentrador: IConcentrador;
        resultado: string;
  T1 : Cardinal;
  T2 : Cardinal;
  sT : string;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        T1 := GetTickCount;
        concentrador := comunicacao.GetVersaoConcentrador();
        T2 := GetTickCount;
        sT := FormatFloat(',0', T2 - T1) + 'ms';
        resultado := Concat('Numero de Srie   : ' + concentrador.NumeroSerie + chr(10) + chr(13) +
                            'Verso do Hardware: ' + concentrador.VersaoHardware + chr(10) + chr(13) +
                            'FirmwareBIOS      : ' + concentrador.FirmwareBIOS + chr(10) + chr(13) +
                            'FirmwareAplicativo: ' + concentrador.FirmwareAplicativo + chr(10) + chr(13) +
                            'T:' + sT);
        Showmessage(resultado);
end;

procedure TfrmPrincipal.btnLiberaAbsClick(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.LiberacaoAbastece(1, EAcaoBico_Liberar_Cartao_Ok, '1000','900');
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

procedure TfrmPrincipal.btnPAFECFClick(Sender: TObject);
var
        abastecimento: IAbastecimento;
        status: WideString;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        abastecimento := comunicacao.GetLeituraDeAbastecimentoPAFECF();
        if abastecimento <> nil then
                begin
                        case abastecimento.Status of
                                EStatusAbastecimento_ValidoNaoApagado: begin
                                status := 'Valido Nao Apagado';
                                end;
                                EStatusAbastecimento_ValidoLidoNaoApagado: begin
                                status := 'Valido Lido Nao Apagado';
                                end;
                                EStatusAbastecimento_ValidoApagado: begin
                                status := 'Valido Apagado';
                                end;
                        end;
                        Showmessage('Abastecimento'  + chr(10) + chr(13) +
                                    'ID          : ' + IntToStr(12) + chr(10) + chr(13) +
                                    'Bico        : ' + FloatToStr(abastecimento.Bico.Numero) + chr(10) + chr(13) +
                                    'Valor Abast.: ' + FloatToStr(abastecimento.ValorAbastecido) + chr(10) + chr(13) +
                                    'Litros Abast: ' + FloatTOStr(abastecimento.LitrosAbastecidos) + chr(10) + chr(13) +
                                    'Valor Uni   : ' + FloatTOStr(abastecimento.ValorPorLitro) + chr(10) + chr(13) +
                                    'Ini. Litros : ' + abastecimento.Bico.EncerranteLitroInicial + chr(10) + chr(13) +
                                    'Enc. Litros : ' + abastecimento.Bico.EncerranteLitro + chr(10) + chr(13) +
                                    'Data        : ' + FloatTOStr(abastecimento.DataHora) + chr(10) + chr(13) +
                                    'Funcionrio : ' + abastecimento.CartaoFuncionario.Codigo + chr(10) + chr(13) +
                                    'Cliente     : ' + abastecimento.CartaoCliente.Endereco + chr(10) + chr(13) +
                                    'Veculo     : ' + abastecimento.CartaoVeiculo.Endereco + chr(10) + chr(13) +
                                    'Motorista   : ' + abastecimento.CartaoMotorista.Endereco + chr(10) + chr(13) +
                                    'Endereo    : ' + abastecimento.Endereco + chr(10) + chr(13) +
                                    'Status      : ' + status);
                        comunicacao.SetConfirmacaoLeituraAbastecimento(abastecimento);
                        Showmessage('Confirmao da leitura efetuada com sucesso.');
                end
        else
                Showmessage('Nenhum abastecimento')
end;

//Seta o relgio do concentrador.
procedure TfrmPrincipal.btnSetRelogioClick(Sender: TObject);
var
        data: TDateTime;
        strData: WideString;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        data := Now;
        strData := formatdatetime('yymmddhhnnss',data);
        comunicacao.SetRelogioConcentrador(strData);
        Showmessage('Operao realizada com sucesso.')
end;

//Busca o relgio do concentrador.
procedure TfrmPrincipal.btnGetRelogioClick(Sender: TObject);
var
        data: TDateTime;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        data := comunicacao.GetRelogioConcentrador;
//        Showmessage(DateTimeToStr(data));
        Showmessage(DateToStr(data));
end;

//Seta as configuraes.
procedure TfrmPrincipal.btnSetBicoClick(Sender: TObject);
var
        bico: IBico;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        bico := CoBico.Create;
        bico.Numero := 1;
        bico.Slot := 0;
        bico.Canal := 0;
        bico.Modelo := ord(chr(162));
        bico.Modo := ord('A');
        bico.VirgulaPU := 3;
        bico.EnderecoLogico := 1;
        bico.PosicaoFisica := 1;
        bico.PosicaoLogica := 0;
        bico.Template := 'Gilbarco_Legacy_1';
        statusComando := comunicacao.SetConfiguracaoBico(bico);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Busca a configurao do bico.
procedure TfrmPrincipal.btnGetConfigBicoClick(Sender: TObject);
var
        bico: IBico;
        resultado: string;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        bico := comunicacao.GetConfiguracaoBico(1);
        resultado := Concat('Numero        : ' + IntToStr(bico.Numero) + chr(10) + chr(13) +
                            'Slot          : ' + IntToStr(bico.Slot) + chr(10) + chr(13) +
                            'Canal         : ' + IntToStr(bico.Canal) + chr(10) + chr(13) +
                            'Modelo        : ' + char(bico.Modelo) + chr(10) + chr(13) +
                            'Modo          : ' + char(bico.Modo) + chr(10) + chr(13) +
                            'VirgulaPU     : ' + IntToStr(bico.VirgulaPU) + chr(10) + chr(13) +
                            'EnderecoLogico: ' + IntToStr(bico.EnderecoLogico) + chr(10) + chr(13) +
                            'PosicaoFisica : ' + IntToStr(bico.PosicaoFisica) + chr(10) + chr(13) +
                            'PosicaoLogica : ' + IntToStr(bico.PosicaoLogica) + chr(10) + chr(13) +
                            'Template      : ' + bico.Template);
        Showmessage(resultado);
end;

//Busca o Status do bico.
procedure TfrmPrincipal.btnGetStatusBicoClick(Sender: TObject);
var
        bico: IBico;
        status: string;
        cartao: string;
        resultado: string;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        bico := comunicacao.GetStatusBico(1);
        cartao := '';
        case bico.Status of
                EStatusBico_Livre: begin
                        status := 'Bico Livre';
                end;
                EStatusBico_Ocupado: begin
                        status := 'Bico Ocupado';
                end;
                EStatusBico_SemComunicacao: begin
                        status := 'Bico Sem Comunicao';
                end;
                EStatusBico_LivreBloqueada: begin
                        status := 'Bico Livre Bloqueado';
                end;
                EStatusBico_OcupadaBloqueada: begin
                        status := 'Bico Ocupado Bloqueado';
                end;
                EStatusBico_SolicitandoLiberacaoSemCartao: begin
                        status := 'Bico Solicitando Liberao sem Carto';
                end;
                EStatusBico_SolicitandoLiberacaoComCartao: begin
                        status := 'Bico Solicitando Liberao com Carto';
                end;
                EStatusBico_Inexistente: begin
                        status := 'Bico Inexistente';
                end;
                EStatusBico_SemConfiguracao: begin
                        status := 'Bico Sem Configurao';
                end;
        end;
        if (bico.Cartao<>nil) then
          cartao := bico.Cartao.Codigo;
        resultado := Concat('Numero: ' + IntToStr(bico.Numero) + chr(10) + chr(13) +
                            'Cartao: ' + cartao + chr(10) + chr(13) +
                            'Status: ' + status);
        Showmessage(resultado);
end;

procedure TfrmPrincipal.btnGetStMedidorClick(Sender: TObject);
var
        medidor: SMedidor;
        resultado: string;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        medidor := comunicacao.GetStatusMedidor(1);
        if medidor.ErroLeitura=1 then
          resultado := 'Erro de Leitura.'
        else
          resultado := Concat('Medidor/Tanque: ' + IntToStr(medidor.NumeroTanque) + chr(10) + chr(13) +
                              'Total Litros  : ' + IntToStr(medidor.TotalLitros) + chr(10) + chr(13) +
                              'Litros Combust: ' + IntToStr(medidor.CombustivelLitros) + chr(10) + chr(13) +
                              'Litros gua   : ' + IntToStr(medidor.AguaLitros));
        Showmessage(resultado);
end;

//Efetua a leitura de um abastecimento e apaga do Concentrador.
procedure TfrmPrincipal.btnGetAbastecimentoClick(Sender: TObject);
var
        abastecimento: IAbastecimento;
        status: WideString;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        abastecimento := comunicacao.GetLeituraDeAbastecimento();
        if abastecimento <> nil then
                begin
                        case abastecimento.Status of
                                EStatusAbastecimento_ValidoNaoApagado: begin
                                status := 'Valido Nao Apagado';
                                end;
                                EStatusAbastecimento_ValidoLidoNaoApagado: begin
                                status := 'Valido Lido Nao Apagado';
                                end;
                                EStatusAbastecimento_ValidoApagado: begin
                                status := 'Valido Apagado';
                                end;
                        end;
                        Showmessage('Abastecimento'  + chr(10) + chr(13) +
                                    'ID          : ' + IntToStr(12) + chr(10) + chr(13) +
                                    'Bico        : ' + FloatToStr(abastecimento.Bico.Numero) + chr(10) + chr(13) +
                                    'Valor Abast.: ' + FloatToStr(abastecimento.ValorAbastecido) + chr(10) + chr(13) +
                                    'Litros Abast: ' + FloatTOStr(abastecimento.LitrosAbastecidos) + chr(10) + chr(13) +
                                    'Valor Uni   : ' + FloatTOStr(abastecimento.ValorPorLitro) + chr(10) + chr(13) +
                                    'Enc. Litros : ' + abastecimento.Bico.EncerranteLitro + chr(10) + chr(13) +
                                    'Data        : ' + FloatTOStr(abastecimento.DataHora) + chr(10) + chr(13) +
                                    'Funcionrio : ' + abastecimento.CartaoFuncionario.Endereco + chr(10) + chr(13) +
                                    'Cliente     : ' + abastecimento.CartaoCliente.Endereco + chr(10) + chr(13) +
                                    'Veculo     : ' + abastecimento.CartaoVeiculo.Endereco + chr(10) + chr(13) +
                                    'Motorista   : ' + abastecimento.CartaoMotorista.Endereco + chr(10) + chr(13) +
                                    'Endereo    : ' + abastecimento.Endereco + chr(10) + chr(13) +
                                    'Status      : ' + status);
                        comunicacao.SetConfirmacaoLeituraAbastecimento(abastecimento);
                        Showmessage('Confirmao da leitura efetuada com sucesso.');
                end
        else
                Showmessage('Nenhum abastecimento')

end;

//Efetua a leitura de um abastecimento sem apagar da memria do Concentrador.
procedure TfrmPrincipal.btnGetAbastSemApagarClick(Sender: TObject);
var
        abastecimento: IAbastecimento;
        status: WideString;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        abastecimento := comunicacao.GetLeituraDeAbastecimentoSemApagar();
        if abastecimento <> nil then
                begin
                        case abastecimento.Status of
                                EStatusAbastecimento_ValidoNaoApagado: begin
                                status := 'Valido Nao Apagado';
                                end;
                                EStatusAbastecimento_ValidoLidoNaoApagado: begin
                                status := 'Valido Lido Nao Apagado';
                                end;
                                EStatusAbastecimento_ValidoApagado: begin
                                status := 'Valido Apagado';
                                end;
                        end;
                        Showmessage('Abastecimento'  + chr(10) + chr(13) +
                                    'ID          : ' + IntToStr(12) + chr(10) + chr(13) +
                                    'Bico        : ' + FloatToStr(abastecimento.Bico.Numero) + chr(10) + chr(13) +
                                    'Valor Abast.: ' + FloatToStr(abastecimento.ValorAbastecido) + chr(10) + chr(13) +
                                    'Litros Abast: ' + FloatTOStr(abastecimento.LitrosAbastecidos) + chr(10) + chr(13) +
                                    'Valor Uni   : ' + FloatTOStr(abastecimento.ValorPorLitro) + chr(10) + chr(13) +
                                    'Enc. Litros : ' + abastecimento.Bico.EncerranteLitro + chr(10) + chr(13) +
                                    'Data        : ' + FloatTOStr(abastecimento.DataHora) + chr(10) + chr(13) +
                                    'Funcionrio : ' + abastecimento.CartaoFuncionario.Endereco + chr(10) + chr(13) +
                                    'Cliente     : ' + abastecimento.CartaoCliente.Endereco + chr(10) + chr(13) +
                                    'Veculo     : ' + abastecimento.CartaoVeiculo.Endereco + chr(10) + chr(13) +
                                    'Motorista   : ' + abastecimento.CartaoMotorista.Endereco + chr(10) + chr(13) +
                                    'Endereo    : ' + abastecimento.Endereco + chr(10) + chr(13) +
                                    'Status      : ' + status);
                        comunicacao.SetConfirmacaoLeituraAbastecimentoSemApagar(abastecimento);
                        Showmessage('Confirmao da leitura efetuada com sucesso.');
                end
        else
                Showmessage('Nenhum abastecimento')
end;

procedure TfrmPrincipal.btnGetAbs3Click(Sender: TObject);
var
        abastecimento: IAbastecimento;
        status: WideString;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        abastecimento := comunicacao.GetLeituraDeAbastecimentoPT();
        if abastecimento <> nil then
                begin
                        case abastecimento.Status of
                                EStatusAbastecimento_ValidoNaoApagado: begin
                                status := 'Valido Nao Apagado';
                                end;
                                EStatusAbastecimento_ValidoLidoNaoApagado: begin
                                status := 'Valido Lido Nao Apagado';
                                end;
                                EStatusAbastecimento_ValidoApagado: begin
                                status := 'Valido Apagado';
                                end;
                        end;
                        Showmessage('Abastecimento'  + chr(10) + chr(13) +
                                    'ID           : ' + IntToStr(12) + chr(10) + chr(13) +
                                    'Bico         : ' + FloatToStr(abastecimento.Bico.Numero) + chr(10) + chr(13) +
                                    'Valor Abast. : ' + FloatToStr(abastecimento.ValorAbastecido) + chr(10) + chr(13) +
                                    'Litros Abast : ' + FloatTOStr(abastecimento.LitrosAbastecidos) + chr(10) + chr(13) +
                                    'Tempo-s Abast: ' + IntToStr(abastecimento.TempoDeAbastecimento) + chr(10) + chr(13) +
                                    'Valor Uni    : ' + FloatTOStr(abastecimento.ValorPorLitro) + chr(10) + chr(13) +
                                    'Ini. Litros  : ' + abastecimento.Bico.EncerranteLitroInicial + chr(10) + chr(13) +
                                    'Enc. Litros  : ' + abastecimento.Bico.EncerranteLitro + chr(10) + chr(13) +
                                    'Data         : ' + FloatTOStr(abastecimento.DataHora) + chr(10) + chr(13) +
                                    'Funcionrio  : ' + abastecimento.CartaoFuncionario.Endereco + chr(10) + chr(13) +
                                    'Cliente      : ' + abastecimento.CartaoCliente.Endereco + chr(10) + chr(13) +
                                    'Veculo      : ' + abastecimento.CartaoVeiculo.Endereco + chr(10) + chr(13) +
                                    'Motorista    : ' + abastecimento.CartaoMotorista.Endereco + chr(10) + chr(13) +
                                    'Endereo     : ' + abastecimento.Endereco + chr(10) + chr(13) +
                                    'Status       : ' + status);
                        comunicacao.SetConfirmacaoLeituraAbastecimento(abastecimento);
                        Showmessage('Confirmao da leitura efetuada com sucesso.');
                end
        else
                Showmessage('Nenhum abastecimento')
end;

//Efetua a leitura de um abastecimento de uma posio da memria.
procedure TfrmPrincipal.btnGetMemoriaAbastClick(Sender: TObject);
var
        abastecimento: IAbastecimento;
        status: WideString;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        abastecimento := comunicacao.GetMemoriaDeAbastecimentos('0195');
        if abastecimento <> nil then
                begin
                        case abastecimento.Status of
                                EStatusAbastecimento_ValidoNaoApagado: begin
                                status := 'Valido Nao Apagado';
                                end;
                                EStatusAbastecimento_ValidoLidoNaoApagado: begin
                                status := 'Valido Lido Nao Apagado';
                                end;
                                EStatusAbastecimento_ValidoApagado: begin
                                status := 'Valido Apagado';
                                end;
                        end;
                        Showmessage('Abastecimento'  + chr(10) + chr(13) +
                                    'ID          : ' + IntToStr(12) + chr(10) + chr(13) +
                                    'Bico        : ' + FloatToStr(abastecimento.Bico.Numero) + chr(10) + chr(13) +
                                    'Valor Abast.: ' + FloatToStr(abastecimento.ValorAbastecido) + chr(10) + chr(13) +
                                    'Litros Abast: ' + FloatTOStr(abastecimento.LitrosAbastecidos) + chr(10) + chr(13) +
                                    'Valor Uni   : ' + FloatTOStr(abastecimento.ValorPorLitro) + chr(10) + chr(13) +
                                    'Enc. Litros : ' + abastecimento.Bico.EncerranteLitro + chr(10) + chr(13) +
                                    'Data        : ' + FloatTOStr(abastecimento.DataHora) + chr(10) + chr(13) +
                                    'Funcionrio : ' + abastecimento.CartaoFuncionario.Endereco + chr(10) + chr(13) +
                                    'Cliente     : ' + abastecimento.CartaoCliente.Endereco + chr(10) + chr(13) +
                                    'Veculo     : ' + abastecimento.CartaoVeiculo.Endereco + chr(10) + chr(13) +
                                    'Motorista   : ' + abastecimento.CartaoMotorista.Endereco + chr(10) + chr(13) +
                                    'Endereo    : ' + abastecimento.Endereco + chr(10) + chr(13) +
                                    'Status      : ' + status);
                end
        else
                Showmessage('Nenhum abastecimento')
end;

//Busca os encerrantes do bico.
procedure TfrmPrincipal.Button10Click(Sender: TObject);
var
  Arquivo_entrada: string;
  arquivo_saida: string;
  fe: File;
  fs: File;
  Block: array[1..64] of Byte;
  iRead,iWrite: Integer;
  i: Integer;
begin
  Arquivo_entrada:='K:\Arquivos de projetos\HIRO - verity\DelphiTeste\veiculos.hir';
  arquivo_saida:='K:\Arquivos de projetos\HIRO - verity\DelphiTeste\veiculos.txt';

  AssignFile(fe, Arquivo_entrada);
  FileMode := fmOpenRead;
  Reset(fe, 1);

  AssignFile(fs, arquivo_saida);
  FileMode := fmOpenWrite;
  ReWrite(fs, 1);

  repeat
   //begin
     BlockRead(fe, Block, SizeOf(Block),iRead);
     for i:=1 to iRead do
      Block[i] := Block[i] XOR 106;

     BlockWrite(fs, Block, iRead, iWrite);
   //end;
  until (iRead = 0) or (iWrite <> iRead);
   CloseFile(fe);
   CloseFile(fs);

end;

procedure TfrmPrincipal.Button11Click(Sender: TObject);
var
        status: Descarga;
        resultado: string;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        status := comunicacao.GetDescarga();

        if (status.ErroLeitura=1) then
          resultado:='Erro de Leitura!'
        else if (status.SemDescargas=1) then
          resultado:='Sem Descargas!'
        else
          resultado:=Concat('Numero Tanque:',IntToStr(status.numero_tanque),chr(10)+chr(13),
                            'Incio   :',status.data_inicio,' ',status.hora_inicio,chr(10)+chr(13),
                            'Final        :',status.data_fim,' ',status.hora_fim,chr(10)+chr(13),
                            'Volume L     :',IntToStr(status.volume_descarga));
        Showmessage(resultado);
end;

procedure TfrmPrincipal.Button12Click(Sender: TObject);
var
  status: SMedidor;
  resultado: string;
begin
  comunicacao :=  TComunicacaoDelphi.Create(nil);
  status := comunicacao.GetStatusTank(1);
  if (status.ErroLeitura=1) or (status.SemComunicacao=1) or (status.SemTabela=1) then
    resultado := 'Medidor do Tanque 1 com problemas:'+ chr(10) + chr(13) +
                  'ErroLeitura: '    + IntToStr(status.ErroLeitura) + chr(10) + chr(13) +
                  'SemComunicacao: ' + IntToStr(status.SemComunicacao) + chr(10) + chr(13) +
                  'SemTabela: '      + IntToStr(status.SemTabela)
  else
  begin
    if (status.TanqueAtivo<>1) then
      resultado := 'Tanque 1 inativo.'
    else
      resultado := Concat('Cd.Combustivel:',status.Combustivel,chr(10) + chr(13),
                        'Capacidade L   :',IntToStr(status.TotalLitros),chr(10) + chr(13),
                        'Combustvel L  :',IntToStr(status.CombustivelLitros),chr(10) + chr(13),
                        'Temperatura    :',FloatToStr(status.CombustivelTemperatura),chr(10) + chr(13)
                        );
  end;
  Showmessage(resultado);
end;

procedure TfrmPrincipal.Button13Click(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        comunicacao.SetConfirmaDescarga(1);
        Showmessage('Operao realizada com sucesso.');
end;

procedure TfrmPrincipal.Button1Click(Sender: TObject);
var
        bico: IBico;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        bico := comunicacao.GetEncerrantesBico(1);
        if (bico <> nil) then
                Showmessage('Encerrante Valor  :' + bico.EncerranteValor + chr(10) + chr(13) +
                            'Encerrante Litros : ' + bico.EncerranteLitro )
        else
                Showmessage('Impossvel localizar os encerrantes.');
end;

//Busca o preo configurado no bico.
procedure TfrmPrincipal.btnGetPrecoBicoClick(Sender: TObject);
var
        bico: IBico;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        bico := comunicacao.GetPrecoDoBico(1);
        if (bico <> nil) then
                Showmessage('Valor por Litro:' + FloatTOStr(bico.ValorPorLitro))
        else
                Showmessage('Impossvel localizar o valor cobrado no bico.');
end;

//Seta o preo cobrado no bico.
procedure TfrmPrincipal.btnSetPrecoBicoClick(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        //statusComando := comunicacao.SetPrecoBico(1,'3899');  //R$ 3,899
        statusComando := comunicacao.SetPrecoBico(1,'4399');  //R$ 4,339
        //statusComando := comunicacao.SetPrecoBico(1,'3000'); //R$ 3,000
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Libera o bico para abastecimentos.
procedure TfrmPrincipal.btnDesbloquearBicoClick(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.DesbloquearBico(1);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Bloqueia o bico para abastecimentos.
procedure TfrmPrincipal.btnBloquearBicoClick(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.BloquearBico(1);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Libera um abastecimento definindo o valor.
procedure TfrmPrincipal.btnsetValorAbastClick(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.SetValorAbastecimento(1, '5000');
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Libera um abastecimento definindo a quantidade de litros.
procedure TfrmPrincipal.btnSetLitrosAbastClick(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.SetLitrosAbastecimento(1,'20');
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Efetua um cadastro de carto.
procedure TfrmPrincipal.btnSetCartaoClick(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.SetCadastroDeCartao(ETipoCartao_Funcionario, '14121634');
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Busca o carto pelo cdigo.
procedure TfrmPrincipal.btnGetCartao1Click(Sender: TObject);
var
        cartao: ICartao;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        cartao := comunicacao.GetCadastroDeCartao_2('14121634', ETipoCartao_Funcionario);
        if cartao <> nil then
                Showmessage('Carto: ' + cartao.Codigo)
        else
                Showmessage('Nenhum carto encontrado.')
end;

//Busca o carto pelo endereo de memria.
procedure TfrmPrincipal.btnGetCartao2Click(Sender: TObject);
var
        cartao: ICartao;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        cartao := comunicacao.GetCadastroDeCartao(ETipoCartao_Funcionario, '1');
        if cartao <> nil then
                Showmessage('Carto: ' + cartao.Codigo)
        else
                Showmessage('Nenhum carto encontrado.')
end;

//Deleta um carto pelo cdigo.
procedure TfrmPrincipal.btnDeleteCartao1Click(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.DeletaRegistroDeCartao('14121634', ETipoCartao_Funcionario);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Deleta um carto de uma posio de memria.
procedure TfrmPrincipal.btnDeleteCartao2Click(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.DeletaRegistroDeCartao_2(ETipoCartao_Funcionario, '1');
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Deleta todo o registro de cartes de um determinado tipo.
procedure TfrmPrincipal.btnDeleteCartao3Click(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.DeletaRegistroDeCartao_3(ETipoCartao_Funcionario);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Limpa toda a configurao de bicos
procedure TfrmPrincipal.btnApagarConfiguracaoClick(Sender: TObject);
var
        resultado: boolean;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        resultado := comunicacao.ApagarConfiguracao();
        if resultado = true then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Limpa os abastecimentos da memria do concentrador.
procedure TfrmPrincipal.btnApagarAbastClick(Sender: TObject);
var
        resultado: boolean;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        resultado := comunicacao.ApagarAbastecimentos();
        if resultado = true then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Seta a configurao para comunicao via LAN.
procedure TfrmPrincipal.btnSetConfigLANClick(Sender: TObject);
var
        configuracao: SConfiguracaoTCPIP;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        configuracao.EnderecoIP := '10.1.1.200';
        configuracao.Porta := '3001';
        configuracao.Gateway := '10.1.1.1';
        configuracao.DNS := '10.1.1.1';
        configuracao.Mascara := '255.255.255.0';
        configuracao.DHCP := 0;
        statusComando := comunicacao.SetConfiguracaoLan(configuracao);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Busca a configurao da LAN.
procedure TfrmPrincipal.btnGetConfigLANClick(Sender: TObject);
var
        configuracao: SConfiguracaoTCPIP;
        usaDHCP: PChar;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        configuracao := comunicacao.GetConfiguracaoLan();
        if (configuracao.DHCP = 1) then
                usaDHCP := 'True'
        else
                usaDHCP := 'False';
        Showmessage('Endereo IP: ' + configuracao.EnderecoIP + chr(10) + chr(13) +
                    'Porta      : ' + configuracao.Porta + chr(10) + chr(13) +
                    'Gateway    : ' + configuracao.Gateway + chr(10) + chr(13) +
                    'DNS        : ' + configuracao.DNS + chr(10) + chr(13) +
                    'Mascara    : ' + configuracao.Mascara + chr(10) + chr(13) +
                    'DHCP       : ' + usaDHCP);
end;

//Seta a configurao do servidor SMTP.
procedure TfrmPrincipal.btnSetConfigSMTPClick(Sender: TObject);
var
        configuracao: SConfiguracaoEmail;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        configuracao.Endereco := 'teste.hiro.com.br';
        configuracao.Porta := '587';
        statusComando := comunicacao.SetConfiguracaoServidorSMTP(configuracao);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Busca a configurao do servidor SMTP.
procedure TfrmPrincipal.btnGetConfigSMTPClick(Sender: TObject);
var
        configuracao: SConfiguracaoEmail;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        configuracao := comunicacao.GetConfiguracaoServidorSMTP2();
        Showmessage('Endereo: ' + configuracao.Endereco + chr(10) + chr(13) +
                    'Porta   : ' + configuracao.Porta);
end;

//Seta as configuraes do usurio SMTP
procedure TfrmPrincipal.btnSetUserSMTPClick(Sender: TObject);
var
        configuracao: SConfiguracaoEmail;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        configuracao.Endereco := 'teste.hiro.com.br';
        configuracao.Porta := '587';
        configuracao.Usuario := 'teste@hiro.net.br';
        configuracao.Senha := 'teste';
        configuracao.Autenticacao := 1;
        configuracao.IdentificacaoPosto := 'Crazy Posto';
        statusComando := comunicacao.SetConfiguracaoUsuarioSMTP(configuracao);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

//Busca as Configuraes do usurio SMTP
procedure TfrmPrincipal.btnGetUserSMTPClick(Sender: TObject);
var
        configuracao: SConfiguracaoEmail;
        resultado: String;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        configuracao := comunicacao.GetConfiguracaoUsuarioSMTP2();
        if (configuracao.Autenticacao = 1) then
                resultado := 'True'
        else
                resultado := 'False';
        Showmessage('Usuario           : ' + configuracao.Usuario + chr(10) + chr(13) +
                    'Senha             : ' + configuracao.Senha + chr(10) + chr(13) +
                    'Autenticacao      : ' + IntToStr(configuracao.Autenticacao) + chr(10) + chr(13) +
                    'IdentificacaoPosto: ' + resultado);
end;

//Seta os destiatrios posto(P) e tcnicos(T)
procedure TfrmPrincipal.Button2Click(Sender: TObject);
var
        destinatario: SDestinatarioSMTP;
        resultado: String;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        //Seta os destinatrios posto
        destinatario.Codigo := 1;
        destinatario.tipo := ord('P');
        destinatario.Email := 'teste1@posto.com.br';
        statusComando := comunicacao.SetDestinatarioSMTP(destinatario);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                resultado := 'Destinatrio posto 1 cadastrado com sucesso.' + chr(10) + chr(13)
        else
                resultado := 'Erro ao cadastrar destinatrio posto 1.' + chr(10) + chr(13);

        destinatario.Codigo := 2;
        destinatario.tipo := ord('P');
        destinatario.Email := 'teste2@posto.com.br';
        statusComando := comunicacao.SetDestinatarioSMTP(destinatario);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                resultado := resultado + 'Destinatrio posto 2 cadastrado com sucesso.' + chr(10) + chr(13)
        else
                resultado := resultado + 'Erro ao cadastrar destinatrio posto 2.' + chr(10) + chr(13);

        destinatario.Codigo := 3;
        destinatario.tipo := ord('P');
        destinatario.Email := 'teste3@posto.com.br';
        statusComando := comunicacao.SetDestinatarioSMTP(destinatario);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                resultado := resultado + 'Destinatrio posto 3 cadastrado com sucesso.' + chr(10) + chr(13)
        else
                resultado := resultado + 'Erro ao cadastrar destinatrio posto 3.' + chr(10) + chr(13);

        destinatario.Codigo := 4;
        destinatario.tipo := ord('P');
        destinatario.Email := 'teste4@posto.com.br';
        statusComando := comunicacao.SetDestinatarioSMTP(destinatario);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                resultado := resultado + 'Destinatrio posto 4 cadastrado com sucesso.' + chr(10) + chr(13)
        else
                resultado := resultado + 'Erro ao cadastrar destinatrio posto 4.' + chr(10) + chr(13);

        resultado := resultado + '----------------------------------------------------------' + chr(10) + chr(13);

        //Seta os destinatrios tecnica
        destinatario.Codigo := 1;
        destinatario.tipo := ord('T');
        destinatario.Email := 'teste1@tecnica.com.br';
        statusComando := comunicacao.SetDestinatarioSMTP(destinatario);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                resultado := resultado + 'Destinatrio tecnica 1 cadastrado com sucesso.' + chr(10) + chr(13)
        else
                resultado := resultado + 'Erro ao cadastrar destinatrio tecnica 1.' + chr(10) + chr(13);

        destinatario.Codigo := 2;
        destinatario.tipo := ord('T');
        destinatario.Email := 'teste2@tecnica.com.br';
        statusComando := comunicacao.SetDestinatarioSMTP(destinatario);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                resultado := resultado + 'Destinatrio tecnica 2 cadastrado com sucesso.' + chr(10) + chr(13)
        else
                resultado := resultado + 'Erro ao cadastrar destinatrio tecnica 2.' + chr(10) + chr(13);

        destinatario.Codigo := 3;
        destinatario.tipo := ord('T');
        destinatario.Email := 'teste3@tecnica.com.br';
        statusComando := comunicacao.SetDestinatarioSMTP(destinatario);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                resultado := resultado + 'Destinatrio tecnica 3 cadastrado com sucesso.' + chr(10) + chr(13)
        else
                resultado := resultado + 'Erro ao cadastrar destinatrio tecnica 3.' + chr(10) + chr(13);

        destinatario.Codigo := 4;
        destinatario.tipo := ord('T');
        destinatario.Email := 'teste4@tecnica.com.br';
        statusComando := comunicacao.SetDestinatarioSMTP(destinatario);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                resultado := resultado + 'Destinatrio tecnica 4 cadastrado com sucesso.' + chr(10) + chr(13)
        else
                resultado := resultado + 'Erro ao cadastrar destinatrio tecnica 4.' + chr(10) + chr(13);
        Showmessage(resultado);
end;

procedure TfrmPrincipal.Button3Click(Sender: TObject);
begin
  testeCom('S');
end;

procedure TfrmPrincipal.Button4Click(Sender: TObject);
begin
  testeCom('U');
end;

procedure TfrmPrincipal.Button5Click(Sender: TObject);
begin
  testeCom('R');
end;

procedure TfrmPrincipal.Button6Click(Sender: TObject);
var
        status: string;
        resultado: string;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        status := comunicacao.LeStatusTodosBicos();
        resultado := Concat('Status dos Bicos: ' + status);
        Showmessage(resultado);
end;

procedure TfrmPrincipal.Button7Click(Sender: TObject);
var
        bico: IBico;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        bico := comunicacao.GetPrecoDoBicoNivel(1,1);
        if (bico <> nil) then
                Showmessage('Valor por Litro:' + FloatTOStr(bico.ValorPorLitro))
        else
                Showmessage('Impossvel localizar o valor cobrado no bico.');
end;

procedure TfrmPrincipal.Button8Click(Sender: TObject);
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        statusComando := comunicacao.SetPrecoBicoNivel(1,1,'0509');  //R$ 05,09
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Operao realizada com sucesso.')
        else
                Showmessage('Falha na operao.')
end;

procedure TfrmPrincipal.Button9Click(Sender: TObject);
var
  Arquivo_entrada: string;
  arquivo_saida: string;
  fe: File;
  fs: File;
  oneByte: Byte;
  i: Integer;
begin
  Arquivo_entrada:='K:\Arquivos de projetos\HIRO - verity\DelphiTeste\veiculos.hir';
  arquivo_saida:='K:\Arquivos de projetos\HIRO - verity\DelphiTeste\veiculos.txt';

  AssignFile(fe, Arquivo_entrada);
  FileMode := fmOpenRead;
  Reset(fe, 1);

  AssignFile(fs, arquivo_saida);
  FileMode := fmOpenWrite;
  ReWrite(fs, 1);

  while not Eof(fe) do
   begin
     BlockRead(fe, oneByte, 1);
     oneByte := oneByte XOR 106;
     BlockWrite(fs, oneByte, 1);
   end;

   CloseFile(fe);
   CloseFile(fs);
end;

procedure TfrmPrincipal.FormShow(Sender: TObject);
var
  strVersion: string;
  aVersion: TArray<String>;
begin
  strVersion := GetAppVersionStr();
  aVersion := strVersion.Split(['.']);
  strVersion := aVersion[0] + '.' + aVersion[1]  + '.' + aVersion[2];
  frmPrincipal.Caption:='Exemplo Delphi v.'+strVersion;
  if (ComboTCP.ItemIndex<0) then begin
    ComboTCP.ItemIndex:=3;
  end;

end;

function TfrmPrincipal.GetAppVersionStr: string;
var
  Exe: string;
  Size, Handle: DWORD;
  Buffer: TBytes;
  FixedPtr: PVSFixedFileInfo;
begin
  Exe := ParamStr(0);
  Size := GetFileVersionInfoSize(PChar(Exe), Handle);
  if Size = 0 then
    RaiseLastOSError;
  SetLength(Buffer, Size);
  if not GetFileVersionInfo(PChar(Exe), Handle, Size, Buffer) then
    RaiseLastOSError;
  if not VerQueryValue(Buffer, '\', Pointer(FixedPtr), Size) then
    RaiseLastOSError;
  Result := Format('%d.%d.%d.%d',
    [LongRec(FixedPtr.dwFileVersionMS).Hi,  //major
     LongRec(FixedPtr.dwFileVersionMS).Lo,  //minor
     LongRec(FixedPtr.dwFileVersionLS).Hi,  //release
     LongRec(FixedPtr.dwFileVersionLS).Lo]) //build
end;

procedure TfrmPrincipal.testeCom(tipo: String);
var
   //ConfiguracaoIP: SConfiguracaoTCPIP;
   //ConfiguracaoSerial : TComunicacaoSerial;

   iTentativa : integer ;
   bConectou : boolean;
   Reg : TRegistry;
   //comunicacao: TComunicacaoDelphi;

Begin
 bConectou := false;

 iTentativa := 0;
 TRY
   //Sugesto do pessoal da hiro mudar no Registros como ser a comunicao..
   Reg := Tregistry.create;
   with Reg do begin
       rootkey:=HKEY_CURRENT_USER;
       Openkey('Software\Hiro\Comunicacao\Parametros\',false);
       if tipo = 'R' then begin //TCP IP
          writestring('Tipo', '2');
          writestring('DNSPadrao','192.168.0.1');
          writestring('Gateway','192.168.0.1');
          writestring('EnderecoIP','192.168.0.44');
          writestring('MascaraSubRede','255.255.255.0');
          writestring('DHCP','0');
          writestring('PortaTCP','3001');
       end;

       if tipo = 'S' then begin //Serial
          writestring('Tipo', '1');
          writestring('PortaCOM','Com5');
       end;

       if tipo = 'U' then begin //USB
          writestring('Tipo', '3');
          writestring('PID', '5893');
          writestring('VID', '49745');
       end;
       closekey;

       //FormSplash.SetMsgUsuario('Comunicando com Automao HIRO..');
       if tipo = 'R' then begin
          comunicacao := TComunicacaoDelphi.Create(nil);

//          ConfiguracaoIP.EnderecoIP := '192.168.0.189';
//          ConfiguracaoIP.Porta      := '3001';
//          ConfiguracaoIP.Gateway    := '192.168.0.1';
//          ConfiguracaoIP.DNS        := '192.168.0.1';
//          ConfiguracaoIP.Mascara    := '255.255.255.0';
//          ConfiguracaoIP.DHCP       := 1;
//
//          statusComando := comunicacao.SetConfiguracaoLan(ConfiguracaoIP);
          //Delay(500);
          statusComunicacao := comunicacao.TestarComunicacao();
          if statusComunicacao  = EStatusDaComunicacaoConcentrador_OK then begin
             ShowMessage('Conexo Hiro realizada com sucesso!');
             bConectou := true;
          end
          else begin
             for iTentativa:=1 to 2 do begin
                 statusComunicacao := comunicacao.TestarComunicacao();
                 //Delay(50);
                 if statusComando =  EStatusDaComunicacaoConcentrador_OK then begin
                    ShowMessage('Conexo Hiro realizada com sucesso!');
                    bConectou := true;
                    Break;
                 end;
             end;
          end;
       end
       else begin
          comunicacao   := TComunicacaoDelphi.Create(nil);
          statusComunicacao := comunicacao.TestarComunicacao();
          if statusComunicacao =  EStatusDaComunicacaoConcentrador_OK then begin
             ShowMessage('Conexo Hiro realizada com sucesso!') ;
             bConectou := true;
          end
          else begin
             for iTentativa:=1 to 2 do begin
                 comunicacao   := TComunicacaoDelphi.Create(nil);
                 statusComunicacao := comunicacao.TestarComunicacao();
                 if statusComando =  EStatusDaComunicacaoConcentrador_OK then begin
                    ShowMessage('Conexo Hiro realizada com sucesso!');
                    bConectou := true;
                    Break;
                 end;
             end;
          end;
       end;
   end;
   Reg.free;
   //Delay(100);
   if not bConectou then begin
     While (statusComunicacao <> EStatusDaComunicacaoConcentrador_OK) and (iTentativa < 3) do begin
           comunicacao         :=  TComunicacaoDelphi.Create(nil);
           statusComunicacao   := comunicacao.TestarComunicacao();
           if statusComunicacao = EStatusDaComunicacaoConcentrador_OK then begin
              ShowMessage('Conexo Hiro realizada com sucesso!');
              bConectou := true;
              break;
           end;
           //Delay(50);
           inc(iTentativa);
     end;
   end;

   if (statusComunicacao <> EStatusDaComunicacaoConcentrador_OK) and (not bConectou) then begin
     ShowMessage('No foi possivel realizar conexo com o concentrador HIRO, verifique !');
     Exit;
   end;

 finally
    comunicacao.Free
 end;
End;

procedure TfrmPrincipal.Timer1Timer(Sender: TObject);
var
        status: string;
        resultado: string;
begin
  if btnTimerStBico.Tag=1 then
  begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        status := comunicacao.LeStatusTodosBicos();
        resultado := status;
        lbDataStatus.Caption:=DateTimeToStr(Now);
        lbResultado.Caption:=resultado;
  end;
end;

//Cadastra os destinatrios posto e tcnica.
procedure TfrmPrincipal.btnGetDestinatariosClick(Sender: TObject);
var
        destinatario: SDestinatarioSMTP;
        resultado: string;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        //Busca os destinatrios posto.
        destinatario := comunicacao.GetDestinatarioSMTP(1, ord('P'));
        resultado := 'Destinatario posto 1: ' + destinatario.Email + chr(10) + chr(13);
        destinatario := comunicacao.GetDestinatarioSMTP(2, ord('P'));
        resultado := resultado + 'Destinatario posto 2: ' + destinatario.Email + chr(10) + chr(13);
        destinatario := comunicacao.GetDestinatarioSMTP(3, ord('P'));
        resultado := resultado + 'Destinatario posto 3: ' + destinatario.Email + chr(10) + chr(13);
        destinatario := comunicacao.GetDestinatarioSMTP(4, ord('P'));
        resultado := resultado + 'Destinatario posto 4: ' + destinatario.Email + chr(10) + chr(13);

        resultado := resultado + '----------------------------------------------------------' + chr(10) + chr(13);

        //Busca os destinatrios tcnica.
        destinatario := comunicacao.GetDestinatarioSMTP(1, ord('T'));
        resultado := resultado + 'Destinatario tcnica 1: ' + destinatario.Email + chr(10) + chr(13);
        destinatario := comunicacao.GetDestinatarioSMTP(2, ord('T'));
        resultado := resultado + 'Destinatario tcnica 2: ' + destinatario.Email + chr(10) + chr(13);
        destinatario := comunicacao.GetDestinatarioSMTP(3, ord('T'));
        resultado := resultado + 'Destinatario tcnica 3: ' + destinatario.Email + chr(10) + chr(13);
        destinatario := comunicacao.GetDestinatarioSMTP(4, ord('T'));
        resultado := resultado + 'Destinatario tcnica 4: ' + destinatario.Email + chr(10) + chr(13);
end;

//Cadastra um tipo de combustvel.
procedure TfrmPrincipal.btnSetCombustivelClick(Sender: TObject);
var
        combustivel: SCombustivel;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        combustivel.Codigo := 1;
        combustivel.Descricao := 'Gasolina Comum';
        statusComando := comunicacao.SetTipoCombustivel(combustivel);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Combustvel cadastrado com sucesso.')
        else
                Showmessage('Erro ao cadastrar combustvel.');
end;

//Busca um combustvel.
procedure TfrmPrincipal.btnGetCombustivelClick(Sender: TObject);
var
        combustivel: SCombustivel;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        combustivel := comunicacao.GetTipoCombustivel(1);
        Showmessage('Combustvel: ' + combustivel.Descricao);
end;

//Cadastra um horrio de envio de totais.
procedure TfrmPrincipal.btnSetHorarioTotaisClick(Sender: TObject);
var
        horario: SHorarioEnvioTotais;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        horario.Codigo := 1;
        horario.Hora := 10;
        horario.Minuto := 12;
        statusComando := comunicacao.SetHorarioEnvioTotais(horario);
        if statusComando = EStatusComando_ComandoProcessadoComSucesso then
                Showmessage('Horrio cadastrado com sucesso.')
        else
                Showmessage('Erro ao cadastrar horrio.');
end;

//Busca um horrio de envio de totais.
procedure TfrmPrincipal.btnGetHorarioTotaisClick(Sender: TObject);
var
        horario: SHorarioEnvioTotais;
begin
        comunicacao :=  TComunicacaoDelphi.Create(nil);
        horario := comunicacao.GetHorarioEnvioTotais(1);
        Showmessage('Horrio: ' + IntToStr(horario.Hora) + ':' + IntToStr(horario.Minuto));
end;

end.
